coord = {}


--[[Note: Math is Hard.
	There seems to be a need for the +2 and -2 in the Y axis functions.
	I don't know why, but they make it work. Can someone explain this?]]


--Change Iso Coordinates to Cartesian Tile Coordinates
function coord.Iso2Grid(xIso,yIso)
	local xGrid = math.floor((xIso/tileWidth)+(yIso/tileDepth)+0.5)
	local yGrid = math.floor((yIso/tileDepth)-(xIso/tileWidth)-0.5)+2
	return xGrid,yGrid
end

--Change Cantesian Tile Coordinates to Iso Coordinates
function coord.Grid2Iso(xGrid,yGrid)
	local xIso = (xGrid-yGrid)*(tileWidth/2)
	local yIso = (xGrid+yGrid-2)*(tileDepth/2)
	return xIso,yIso
end

--Sorting/MapRotation
--o is order, forward 1 or reverse 2
function coord.sortPairsIn(t,o)
	local ordered = {}
	local i = 0
	local n = 0
	while i<t.ln do		
		if t[n] ~= nil then
			if o == 1 then
				table.insert(ordered,n)
			elseif o == 2 then
				table.insert(ordered,1,n)
			end
			i = i+1
		end
		if t[-n] ~= nil and n ~= 0 then
			if o == 1 then
				table.insert(ordered,1,-n)
			elseif o == 2 then
				table.insert(ordered,-n)
			end
			i = i+1
		end
		n = n+1
	end
	return ordered
end

--Create a new Row (entry) in a table, and increment the table's length tracker "ln" by one.
function coord.newRowIn(t)
	t.ln = t.ln+1
	return {ln = 0}
end

function coord.newTileIn(t)
	t.ln = t.ln+1
	local newTile = {}
	newTile.tile = 1
	newTile.height = 0
	return newTile
end

function coord.fixNonExistantTile(x,y,z)
	if map[z] == nil then
		map[z] = coord.newRowIn(map)
		layer[z] = love.graphics.newSpriteBatch(tileset,1000,"dynamic")
	end
	if map[z][y] == nil then
		map[z][y] = coord.newRowIn(map[z])
	end
	if map[z][y][x] == nil then
		map[z][y][x] = coord.newTileIn(map[z][y])
	end
end
